unit Config;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Variants, Controls, Forms,
  StdCtrls, Buttons, ImgList, Menus, ExtCtrls;

type
  TConfigForm = class(TForm)
    ListBox: TListBox;
    Panel2: TPanel;
    BtnAdd: TBitBtn;
    BtnMod: TBitBtn;
    BtnDel: TBitBtn;
    BtnClose: TBitBtn;
    BtnUp: TBitBtn;
    BtnDown: TBitBtn;
    Bevel1: TBevel;
    Bevel2: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure BtnAddClick(Sender: TObject);
    procedure ListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure BtnDelClick(Sender: TObject);
    procedure BtnUpClick(Sender: TObject);
    procedure BtnDownClick(Sender: TObject);
    procedure BtnCloseClick(Sender: TObject);
    procedure BtnModClick(Sender: TObject);
  private
    function ValidItemIndex(var Index: integer): Boolean;
  public

  end;

procedure ShowConfigForm(Owner: TComponent);

implementation

{$R *.DFM}

uses
    Detail, iReminder, DummyMain;

//  ---------------------------------------------------------------------------
//  \
procedure ShowConfigForm(Owner: TComponent);
begin
    try
        with TConfigForm.Create(Owner) do
        begin
            try
                ShowModal();
            finally
                Free();
            end;
        end;
    except
    end;
end;

//  ---------------------------------------------------------------------------
//  tH[
procedure TConfigForm.FormCreate(Sender: TObject);
begin
    Self.Caption := Application.Title + ' - ' + Self.Name;
    ListBox.Count := ConfigList.Count;
end;

//  ---------------------------------------------------------------------------
//  `
procedure TConfigForm.ListBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    Config: TReminderConfig;
    ItemText: string;
    OffsetX, OffsetY: integer;
begin
    Config := ConfigList.Item(Index);
    ItemText := Config.ToString();

    OffsetX := 5;
    OffsetY := (Rect.Bottom - Rect.Top - ListBox.Canvas.TextHeight(ItemText)) div 2;

    Inc(OffsetX, Rect.Left);
    Inc(OffsetY, Rect.Top);

    ListBox.Canvas.TextRect(Rect, OffsetX, OffsetY, ItemText);
end;

//  ---------------------------------------------------------------------------
//  ƑIĂ邩?
function TConfigForm.ValidItemIndex(var Index: integer): Boolean;
begin
    Index := ListBox.ItemIndex;
    Result := (Index <> -1);
end;

//  ---------------------------------------------------------------------------
//  폜
procedure TConfigForm.BtnDelClick(Sender: TObject);
var
    Index: integer;
begin
    if ValidItemIndex(Index) then
    begin
        //  폜
        ConfigList.Delete(ListBox.ItemIndex);
        //  ύX
        ListBox.Count := ConfigList.Count;
        //  Iʒu𒲐
        if (ListBox.Count > 0) then
        begin
            Dec(Index);
            if (Index < 0) then Index := 0;
            ListBox.ItemIndex := Index;
        end;
    end;
end;

//  ---------------------------------------------------------------------------
//  Ɉړ
procedure TConfigForm.BtnUpClick(Sender: TObject);
var
    Index, NewIndex: integer;
begin
    if ValidItemIndex(Index) then
    begin
        if (Index > 0) then
        begin
            NewIndex := Index - 1;
            ConfigList.Move(Index, NewIndex);
            ListBox.ItemIndex := NewIndex;
        end;
    end;
end;

//  ---------------------------------------------------------------------------
//  Ɉړ
procedure TConfigForm.BtnDownClick(Sender: TObject);
var
    Index, NewIndex: integer;
begin
    if ValidItemIndex(Index) then
    begin
        if (Index < ListBox.Count - 1) then
        begin
            NewIndex := Index + 1;
            ConfigList.Move(Index, NewIndex);
            ListBox.ItemIndex := NewIndex;
        end;
    end;
end;

//  ---------------------------------------------------------------------------
//  
procedure TConfigForm.BtnCloseClick(Sender: TObject);
begin
    Self.Close();
end;

//  ---------------------------------------------------------------------------
//  ǉ
procedure TConfigForm.BtnAddClick(Sender: TObject);
begin
    if OpenDetail(Self, nil) then
    begin
        ListBox.Count := ConfigList.Count;
    end;
end;

//  ---------------------------------------------------------------------------
//  ύX
procedure TConfigForm.BtnModClick(Sender: TObject);
var
    Index: integer;
    Config: TReminderConfig;
begin
    if ValidItemIndex(Index) then
    begin
        Config := ConfigList.Item(Index);
        if OpenDetail(Self, Config) then
        begin
            ListBox.Refresh();
        end;
    end;
end;

end.

