unit Detail;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, iReminder, StdCtrls, Buttons, ComCtrls;

type
  TDetailForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SbIconInfo: TSpeedButton;
    SbIconWarn: TSpeedButton;
    SbIconError: TSpeedButton;
    Label5: TLabel;
    SbMsgBalloon: TSpeedButton;
    SbMsgBox: TSpeedButton;
    Label6: TLabel;
    ChkEnable: TCheckBox;
    EditHour: TEdit;
    UpDown1: TUpDown;
    EditMinute: TEdit;
    UpDown2: TUpDown;
    MemText: TMemo;
    BtnOk: TBitBtn;
    BtnCancel: TBitBtn;
    BtnTest: TBitBtn;
    RbFlagDayOfWeek: TRadioButton;
    RbFlagDay: TRadioButton;
    RbMonthDay: TRadioButton;
    RbGetTick: TRadioButton;
    EditFlagDayOfWeek: TEdit;
    EditFlagDay: TEdit;
    EditMonthDay: TEdit;
    EditGetTick: TEdit;
    procedure BtnTestClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BtnOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RbFlagDayOfWeekClick(Sender: TObject);
  private
    FWork: TStringList;
    procedure SetValue();
    procedure GetValue();

    procedure SetEnable();
  public

  end;

function OpenDetail(Owner: TComponent; Target: TReminderConfig): Boolean;

implementation

uses
    iTray;

{$R *.dfm}

//  ---------------------------------------------------------------------------
//  JS}
function OpenDetail(Owner: TComponent; Target: TReminderConfig): Boolean;
var
    Frm: TDetailForm;
    Config: TReminderConfig;
begin
    Frm := TDetailForm.Create(Owner);
    try
        //  VKǉ
        if (Target = nil) then
        begin
            //  ̂
            TempConfig.Create();
            //  ݒʂJ
            Result := (Frm.ShowModal = mrOk);
            //  ǉꂽ炱ŕЕtĂ
            //  Ăяo킪Xg{bNX̍sݒ肳
            if Result then
            begin
                Config := TReminderConfig.Create;
                Config.Assign(TempConfig);
                ConfigList.Add(Config);
            end;
        end
        //  ҏW({̂G炸eXgp̃NXG)
        else
        begin
            TempConfig.Assign(Target);
            //  ݒʂJ
            Result := (Frm.ShowModal = mrOk);
            //  ύXꂽ炱ŕЕtĂ
            if Result then
            begin
                //  ߂
                Target.Assign(TempConfig);
            end;
        end;
    finally
        Frm.Free;
    end;
end;

//  ---------------------------------------------------------------------------
//  tH[
procedure TDetailForm.FormCreate(Sender: TObject);
begin
    Self.Caption := Application.Title + ' - ' + Self.Name;
    FWork := TStringList.Create;
end;

//  ---------------------------------------------------------------------------
//  tH[j
procedure TDetailForm.FormDestroy(Sender: TObject);
begin
    FWork.Free;
end;

//  ---------------------------------------------------------------------------
//  ݒ\
procedure TDetailForm.SetValue();
var
    H, M, S, MS: Word;
begin
    //  L
    ChkEnable.Checked := TempConfig.Enable;
    //  
    DecodeTime(TempConfig.Time, H, M, S, MS);
    EditHour.Text := IntToStr(H);
    EditMinute.Text := IntToStr(M);
    //  ACR
    if (TempConfig.IconType = bitINFO) then SbIconInfo.Down := true else
    if (TempConfig.IconType = bitWARN) then SbIconWarn.Down := true else
    SbIconError.Down := true;
    //  \@
    if (TempConfig.MsgType = mtBALLOON) then SbMsgBalloon.Down := true else
    SbMsgBox.Down := true;
    //  eLXg
    MemText.Text := TempConfig.Text;

    //  tO
    if (TempConfig.TimerType = ttDAYOFWEEK) then RbFlagDayOfWeek.Checked := true else
    RbFlagDay.Checked := true;

    //  tOe
    EditFlagDayOfWeek.Text := TempConfig.FlagTextOfDayOfWeek;
    EditFlagDay.Text := TempConfig.FlagTextOfDay;
end;

//  ---------------------------------------------------------------------------
//  ݒ擾
procedure TDetailForm.GetValue();
begin
    //  L
    TempConfig.Enable := ChkEnable.Checked;
    //  
    TempConfig.Time := StrToTimeDef(Format('%s:%s:00', [EditHour.Text, EditMinute.Text]), 0);
    //  ACR
    if SbIconInfo.Down then TempConfig.IconType := bitINFO else
    if SbIconWarn.Down then TempConfig.IconType := bitWARN else
    TempConfig.IconType := bitERROR;
    //  \@
    if SbMsgBalloon.Down then TempConfig.MsgType := mtBALLOON else
    TempConfig.MsgType := mtBOX;
    //  eLXg
    TempConfig.Text := MemText.Text;

    //  tO
    if RbFlagDayOfWeek.Checked then TempConfig.TimerType := ttDAYOFWEEK else
    TempConfig.TimerType := ttDAY;

    //  tOe
    TempConfig.FlagTextOfDayOfWeek := EditFlagDayOfWeek.Text;
    TempConfig.FlagTextOfDay := EditFlagDay.Text;
end;

//  ---------------------------------------------------------------------------
//  ʕ\
procedure TDetailForm.FormShow(Sender: TObject);
begin
    SetValue();
end;

//  ---------------------------------------------------------------------------
//  eXg
procedure TDetailForm.BtnTestClick(Sender: TObject);
begin
    GetValue();
    TempConfig.Execute();
end;

//  ---------------------------------------------------------------------------
//  m
procedure TDetailForm.BtnOkClick(Sender: TObject);
begin
    GetValue();
end;

//  ---------------------------------------------------------------------------
//  `FbN{bNX`p
type
    TMouseStatus = record
        Downed: Boolean;
        Col: integer;
        Row: integer;
        Rect: TRect;
    end;
var
    CustomState: TMouseStatus = (Downed: false; Col: -1; Row: -1);

//  ---------------------------------------------------------------------------
//  jݒ`FbNI
procedure TDetailForm.SetEnable();
begin
    if (RbFlagDayOfWeek.Checked) then
    begin
        EditFlagDayOfWeek.Enabled := true;
        EditFlagDayOfWeek.SetFocus();
    end
    else if (RbFlagDay.Checked) then
    begin
        EditFlagDay.Enabled := true;
        EditFlagDay.SetFocus();
    end
    else if (RbMonthDay.Checked) then
    begin
        EditMonthDay.Enabled := true;
        EditMonthDay.SetFocus();
    end
    else if (RbGetTick.Checked) then
    begin
        EditGetTick.Enabled := true;
        EditGetTick.SetFocus();
    end;
end;

//  ---------------------------------------------------------------------------
//  [hύX
procedure TDetailForm.RbFlagDayOfWeekClick(Sender: TObject);
begin
    SetEnable();
end;

end.

